// UnitsEditBox.cpp : implementation file
//
#include "UnitsEditBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CUnitsEditBox, CEdit)
/////////////////////////////////////////////////////////////////////////////
// CUnitsEditBox
const CString aSixteenth[] = {_T("NONE"), _T(" 1/16\""), _T(" 1/8\""), _T(" 3/16\""), _T(" 1/4\""),
						_T(" 5/16\""), _T(" 3/8\""), _T(" 7/16\""), _T(" 1/2\""), _T(" 9/16\""),
					    _T(" 5/8\""), _T(" 11/16\""), _T(" 3/4\""), _T(" 13/16\""), _T(" 7/8\""),
					    _T(" 15/16\""), _T("FULL")};

const CString aEighth[] = {_T("NONE"), _T(" 1/8\""), _T(" 1/4\""), _T(" 3/8\""), _T(" 1/2\""),
					_T(" 5/8\""), _T(" 3/4\""), _T(" 7/8\""), _T("FULL")};

const CString aQuarter[] = {_T("NONE"), _T(" 1/4\""), _T(" 1/2\""), _T(" 3/4\""), _T("FULL")};
																			  

const CString aHalf[] = {_T("NONE"), _T(" 1/2\""), _T("FULL")};


CUnitsEditBox::CUnitsEditBox()
{
	m_bImperial = TRUE;
	m_dCurValue = 0.0;
	SetPrecision();
}

CUnitsEditBox::~CUnitsEditBox()
{
}


BEGIN_MESSAGE_MAP(CUnitsEditBox, CEdit)
	//{{AFX_MSG_MAP(CUnitsEditBox)
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUnitsEditBox message handlers
void CUnitsEditBox::SetUnits(BOOL bImperial)
{
	//Check to see wether the box has a value entered
	//if so, update the value to the new unit type
	if(bImperial != m_bImperial)
	{
		m_dCurValue = GetDoubleValue();
		if(ChangeUnits() == TRUE)
		{
			m_bImperial = bImperial;
			m_dCurValue = GetDoubleValue();
		}
	}
	else
		m_bImperial = bImperial;
}

BOOL CUnitsEditBox::VerifyFormat()
{
	BOOL bOk = TRUE;
	CString csTemp, csTest;
	GetWindowText(csTemp);
	if(!csTemp.IsEmpty())
	{
		csTest = FormatString(csTemp);
		csTest.Remove('#');	//Remove numbers
		if(m_bImperial)
		{
			if(strcmp(csTest, "'-\"") != 0)	//1'-0"
			{
				if(strcmp(csTest, "'- /\"") != 0) //1'-1 1/2"
				{
					if(strcmp(csTest, "'") != 0) //1'
					{
						if(strcmp(csTest, "\"") != 0) //1"
						{
							if(strcmp(csTest, "/\"") != 0) //1/2"
							{
								if(strcmp(csTest, " /\"") != 0) //6 1/2"
								{
									if(strcmp(csTest, ".") != 0) //2.5 (inches)
									{
										if(strcmp(csTest, ".'") != 0) //2.5'
											bOk = FALSE;
									}
								}
							}
						}
					}
				}
			}
		}
		else if(!csTest.IsEmpty()) // should be empty, (only excepts mm) 
			bOk = FALSE;
	}
	return bOk;
}

CString CUnitsEditBox::FormatString(CString csString)
{
	CString csTest;
	int nLength = csString.GetLength();
	for(int i = 0; i < nLength; i++)
	{
		char cChar = csString.GetAt(i);
		if(isdigit(cChar))
			csTest += "#";
		else
			csTest += char(cChar);
	}
	return csTest;
}

double CUnitsEditBox::GetDoubleValue()
{
	CString csStringVal;
	GetWindowText(csStringVal);
	double dResult = 0;
	if(m_bImperial)
	{
		if(!csStringVal.IsEmpty())
		{
			CString csTest(csStringVal);
			csTest.Remove('1');
			csTest.Remove('2');
			csTest.Remove('3');
			csTest.Remove('4');
			csTest.Remove('5');
			csTest.Remove('6');
			csTest.Remove('7');
			csTest.Remove('8');
			csTest.Remove('9');
			csTest.Remove('0');

			if(m_bImperial)
			{
				int nFoot, nDash, nDev, nInch, nDec, nSpace;
				nFoot = csStringVal.Find("'");
				nDash = csStringVal.Find("-");
				nDev = csStringVal.Find("/");
				nInch = csStringVal.Find("\"");
				nDec = csStringVal.Find(".");
				nSpace = csStringVal.Find(" ");

				CString csFoot, csInch, csNum, csDenom;
				if(strcmp(csTest, "'-\"") == 0) // 1'-0"
				{
					csFoot = csStringVal.Left(nFoot);
					csInch = csStringVal.Mid(nDash + 1, nInch - (nDash + 1));
					dResult = atof(csFoot) + (atof(csInch) / 12);
				}
				else if(strcmp(csTest, "'- /\"") == 0) //1'-0 1/2"
				{
					csFoot = csStringVal.Left(nFoot);
					csInch = csStringVal.Mid(nDash + 1, nSpace - (nDash + 1));
					csNum = csStringVal.Mid(nSpace + 1, nDev - (nSpace + 1));
					csDenom = csStringVal.Mid(nDev + 1, nInch - (nDev + 1));

					dResult = atof(csFoot) + (atof(csInch) + (atof(csNum) / atof(csDenom))) / 12;
				}
				else if(strcmp(csTest, "'") == 0)
				{
					dResult = atof(csStringVal.Left(nFoot));
				}
				else if(strcmp(csTest, "\"") == 0)
				{
					dResult = atof(csStringVal.Left(nInch)) / 12;
				}
				else if(strcmp(csTest, "/\"") == 0)
				{
					csNum = csStringVal.Left(nDev);
					csDenom = csStringVal.Mid(nDev + 1, nInch - (nDev + 1));

					dResult = (atof(csNum) / atof(csDenom)) / 12;
				}
				else if(strcmp(csTest, " /\"") == 0)
				{
					csInch = csStringVal.Left(nSpace);
					csNum = csStringVal.Mid(nSpace + 1, nDev - (nSpace + 1));
					csDenom = csStringVal.Mid(nDev + 1, nInch - (nDev + 1));
					dResult = (atof(csInch) + (atof(csNum) / atof(csDenom))) / 12;
				}
				else if(strcmp(csTest, ".") == 0)
				{
					dResult = atof(csStringVal) / 12;
				}
				else if(strcmp(csTest, ".'") == 0)
				{
					dResult = atof(csStringVal.Left(nFoot));
				}
			}
		}
	}
	else 
		dResult = atof(csStringVal);
	return dResult;
}

int CUnitsEditBox::GetWindowText(CString &csString)
{
	CWnd::GetWindowText(csString);
	return csString.GetLength();
}

/*double CUnitsEditBox::GetDoubleValue()
{
	double dValue;
	if(m_nUnitType == Imperial || m_nUnitType == Metric)
	{
		dValue = GetDoubleValue();
	}
	if(dValue <= 0)
	{
		CString csTemp;
		GetWindowText(csTemp);
		CString msg;
		msg.Format("Error converting \"%s\" to a double value");
		::AfxMessageBox(msg);
	}
	return dValue;
}*/

BOOL CUnitsEditBox::ChangeUnits()
{
	double dValue = m_dCurValue;
	CString csDimension;
	BOOL bOk = TRUE;
	if(!m_bImperial)
	{
		dValue = (dValue / 25.4) / 12;
		RealToString(dValue, csDimension);
	}
	else 
	{	
		int mm = (int) ((dValue * 12) * 25.4);
		csDimension.Format("%d", mm);
	}
	if(bOk)
		CEdit::SetWindowText(csDimension);
	return bOk;
}

void CUnitsEditBox::SetValue(double dValue)
{
	m_dCurValue = dValue;
	CString csDimension;
	if(!m_bImperial)
		csDimension.Format("%.0lf", dValue);
	else
		RealToString(dValue, csDimension);
	CEdit::SetWindowText(csDimension);
}

void CUnitsEditBox::SetValue(double dValue, BOOL bImperial)
{
	m_bImperial = bImperial;
	m_dCurValue = dValue;
	CString csDimension;
	if(m_bImperial)
		RealToString(dValue, csDimension);
	else
		csDimension.Format("%.0lf", dValue);
	CEdit::SetWindowText(csDimension);
}

void CUnitsEditBox::SetWindowText(CString csValue)
{
	double dValue = atof(csValue);
	CString csFormatted = _T("");
	if(m_bImperial)
		RealToString(dValue, csFormatted);
	else
	{
		int nCut = csValue.Find(".");
		csFormatted = csValue.Left(nCut);
	}
	CEdit::SetWindowText(csFormatted);
}
		
void CUnitsEditBox::SetPrecision(int nPrecision /*= EU_PREC8*/)
{
	m_nPrecision = nPrecision;

	double dValue;
	double dIncrement;

	switch(m_nPrecision)
	{
	case CU_PREC16:
		dValue = 0.03125;
		dIncrement = 0.0625;
		
		break;
	case CU_PREC8:
		dValue = 0.0625;
		dIncrement = 0.125;
		break;
	case CU_PREC4:
		dValue = 0.125;
		dIncrement = 0.25;
		break;
	case CU_PREC2:
		dValue = 0.25;
		dIncrement = 0.5;
		break;
	}

	while (dValue + dIncrement < 1)
	{
		m_Range.push_back(dValue);
		dValue += dIncrement;
	}
}

//==========================================================================================
// Return the fraction
CString CUnitsEditBox::GetFraction(int nIndex)
{
	switch(m_nPrecision)
	{
	case CU_PREC16:
		return aSixteenth[nIndex];
	case CU_PREC8:
		return aEighth[nIndex];
	case CU_PREC4:
		return aQuarter[nIndex];
	case CU_PREC2:
		return aHalf[nIndex];
	}
	return _T("");
}

//==========================================================================================
void CUnitsEditBox::Restore()
{
	CEdit::SetWindowText(m_csOldValue);
}

//==========================================================================================
void CUnitsEditBox::SaveValue()
{
	CEdit::GetWindowText(m_csOldValue);
	
}

//==========================================================================================
void CUnitsEditBox::SelectAll()
{
	SetFocus();
	WORD wLowWord = 0;
	WORD wHighWord = -1;
	SetSel(MAKELONG(wLowWord, wHighWord));
}

//==========================================================================================
void CUnitsEditBox::OnKillFocus(CWnd* pNewWnd) 
{
	if(VerifyFormat())
		CEdit::OnKillFocus(pNewWnd);
	else
	{
		CString csText, csMsg;
		CEdit::SetWindowText("##Invalid##");

		CEdit::SetFocus();
		CEdit::SetSel(0, -1);
	}
}

//==========================================================================================
// Static functions
// Convert real number to string
void CUnitsEditBox::RealToString(/*in*/double dValue, /*out*/CString& csResult)
{
	int nFeet = 0, nInch = 0;
	double dInches = 0.0, dFrac = 0.0;

	nFeet = (int)dValue;
	dInches = (((dValue - nFeet)) * 12);
	nInch = (int)dInches;
	dFrac = dInches - nInch;
		
	CString csFeet, csInch, csFrac, csDimension;
	csFeet = csInch  = "";
	csFrac = _T("\""); //default inch symbol

	int nCount = 0;
	BOOL bFound = FALSE;
	for(m_Iter = m_Range.begin(); m_Iter != m_Range.end() - 1; m_Iter++)
	{	
		double dLow = *m_Iter;
		double dHigh = *(m_Iter + 1);
		if(dFrac >= dLow && dFrac < dHigh) 
		{
			csFrac = GetFraction(nCount + 1);
			bFound = TRUE;
			break;
		}
		++nCount;
	}
	if(!bFound)
	{
		if(dFrac >= 0 && dFrac < *(m_Range.begin()))
			csFrac = "NONE";
		else 
			csFrac = "FULL";
	}
	if(strcmp(csFrac, "FULL") == 0)
	{
		csFrac = _T("\"");
		nInch++;
	}
	else if(strcmp(csFrac, "NONE") == 0)
		csFrac = _T("\"");
	if(nInch == 12)
	{
		nFeet++;
		nInch = 0;
	}
	csInch.Format("%d", nInch);
	if(nFeet > 0)
	{
		csFeet.Format("%d'-", nFeet);
	}
	csResult = csFeet + csInch + csFrac;
}

void CUnitsEditBox::StringToReal(const CString& csInVal, double &dRetVal, BOOL bImperial)
{
	double dResult = 0;
	if(bImperial)
	{
		if(!csInVal.IsEmpty())
		{
			CString csTest(csInVal);
			csTest.Remove('1');
			csTest.Remove('2');
			csTest.Remove('3');
			csTest.Remove('4');
			csTest.Remove('5');
			csTest.Remove('6');
			csTest.Remove('7');
			csTest.Remove('8');
			csTest.Remove('9');
			csTest.Remove('0');

			if(bImperial)
			{
				int nFoot, nDash, nDev, nInch, nDec, nSpace;
				nFoot = csInVal.Find("'");
				nDash = csInVal.Find("-");
				nDev = csInVal.Find("/");
				nInch = csInVal.Find("\"");
				nDec = csInVal.Find(".");
				nSpace = csInVal.Find(" ");

				CString csFoot, csInch, csNum, csDenom;
				if(strcmp(csTest, "'-\"") == 0) // 1'-0"
				{
					csFoot = csInVal.Left(nFoot);
					csInch = csInVal.Mid(nDash + 1, nInch - (nDash + 1));
					dResult = atof(csFoot) + (atof(csInch) / 12);
				}
				else if(strcmp(csTest, "'- /\"") == 0) //1'-0 1/2"
				{
					csFoot = csInVal.Left(nFoot);
					csInch = csInVal.Mid(nDash + 1, nSpace - (nDash + 1));
					csNum = csInVal.Mid(nSpace + 1, nDev - (nSpace + 1));
					csDenom = csInVal.Mid(nDev + 1, nInch - (nDev + 1));

					dResult = atof(csFoot) + (atof(csInch) + (atof(csNum) / atof(csDenom))) / 12;
				}
				else if(strcmp(csTest, "'") == 0)
				{
					dResult = atof(csInVal.Left(nFoot));
				}
				else if(strcmp(csTest, "\"") == 0)
				{
					dResult = atof(csInVal.Left(nInch)) / 12;
				}
				else if(strcmp(csTest, "/\"") == 0)
				{
					csNum = csInVal.Left(nDev);
					csDenom = csInVal.Mid(nDev + 1, nInch - (nDev + 1));

					dResult = (atof(csNum) / atof(csDenom)) / 12;
				}
				else if(strcmp(csTest, " /\"") == 0)
				{
					csInch = csInVal.Left(nSpace);
					csNum = csInVal.Mid(nSpace + 1, nDev - (nSpace + 1));
					csDenom = csInVal.Mid(nDev + 1, nInch - (nDev + 1));
					dResult = (atof(csInch) + (atof(csNum) / atof(csDenom))) / 12;
				}
				else if(strcmp(csTest, ".") == 0)
				{
					dResult = atof(csInVal) / 12;
				}
				else if(strcmp(csTest, ".'") == 0)
				{
					dResult = atof(csInVal.Left(nFoot));
				}
			}
		}
	}
	else 
		dResult = atof(csInVal);
	dRetVal = dResult;
}
